//Andrei Grigorean
#include <fstream>
#include <algorithm>
#include <vector>
#include <bitset>
using namespace std;

#define FILEIN "subgeom.in"
#define FILEOUT "subgeom.out"

const int MAXVAL = 100005;
const int MAXN = 5005;

ifstream fin(FILEIN);
ofstream fout(FILEOUT);

int A[MAXN];							// A[i] = greatest length for a "subsir geometric" having the last element v[i]

int Solve(vector< pair<int, int> > &v) {
	int best = 1;						// length of greatest "subsir geometric" and function's return value
	int N = int(v.size());				// number of elements
	vector< pair<int, int> > u = v;		// make a copy of the array

	sort(v.begin(), v.end());

	// find result for lengths greater than 2
	for (int R = 2; R*R <= MAXVAL; ++R) {
		for (int i = 0; i < N; ++i)
			A[i] = 1;

		int p1 = 0, p2 = 0;
		while (p2 < N && v[p2].first < v[p1].first * R)
			++p2;

		while (p2 < N) {
			if (v[p2].first == v[p1].first * R) {
				int q1 = p1, q2 = p2;
				int sol = 1;

				while (q2 < N && v[q2].first == v[p2].first) {
					while (v[q1].first == v[p1].first && v[q1].second < v[q2].second)
						sol = max(sol, A[q1++] + 1);

					A[q2] = max(A[q2], sol);
					++q2;
				}

				while (v[q1].first == v[p1].first)
					++q1;

				p2 = q2;
				p1 = q1;
			}
			else
				++p1;

			while (p2 < N && v[p2].first < v[p1].first * R)
				++p2;
		}

		for (int i = 0; i < N; ++i)
			best = max(best, A[i]);
	}
	if (best > 1)
		return best;

	// find out if there is a "subsir geometric" of length 2
	bitset<MAXVAL> marked;
	char found = 0;

	for (int i = 0; i < N && !found; ++i) {
		if (marked[u[i].first]) found = 1;
		for (int j = 2*u[i].first; j < MAXVAL; j += u[i].first)
			marked[j] = 1;
	}

	return found ? 2 : 1;
}

int main() {
	int T;
	for (fin >> T; T; --T) {
		int N;
		vector< pair<int, int> > v;

		fin >> N;
		for (int i = 0; i < N; ++i) {
			int val;
			fin >> val;
			v.push_back(make_pair(val, i));
		}

		fout << Solve(v) << endl;
	}
}