#include <cstdio>
#include <cmath>
#include <algorithm>
using namespace std;

#define x first
#define y second

#define FILEIN "dist.in"
#define FILEOUT "dist.out"

const int MAXN = 100005;
const int MAXCOORD = 2000015;

int N;
pair<int, int> v[MAXN];

inline int min(int a, int b) { return (a < b ? a : b); }
inline int max(int a, int b) { return (a > b ? a : b); }

void ReadData() {
	scanf("%d", &N);
	for (int i = 0; i < N; ++i)
		scanf("%d %d", &v[i].x, &v[i].y);
}

int NotSolution(int D) {
	int p1 = 0, p2 = 0;
	int maxy = v[0].y, miny = v[0].y;

	while (p1 < N && (v[p1].x <= v[p2].x + D))
		++p1;

	while (p1 < N) {
		while ((p2 + 1 < N) && (v[p2+1].x + D < v[p1].x)) {
			++p2;
			miny = min(miny, v[p2].y);
			maxy = max(maxy, v[p2].y);
		}

		if (abs(v[p1].y - miny) > D) return 1;
		if (abs(v[p1].y - maxy) > D) return 1;
		
		++p1;
	}

	return 0;
}

int Solve() {
	sort(v, v+N);

	int pow, ret;
	for (pow = 1; (pow << 1) <= MAXCOORD; pow <<= 1);
	for (ret = 0; pow; pow >>= 1)
		if (ret + pow <= MAXCOORD && NotSolution(ret + pow))
			ret += pow;

	return ret + 1;
}

int main() {
	freopen(FILEIN, "r", stdin);
	freopen(FILEOUT, "w", stdout);

	ReadData();
	printf("%d\n", Solve());
}
